//22.05.2022 pro PE
/*
Akusticka signalizace
Mode 0:   bez zvuku
Mode 1:   jedno pipnuti v kazdou celou hodinu
Mode 2:   kazdou celou hodinu pipani poslednich pet sekund s poslednim delsim pipnutim
Mode 3:   Kukacky se signalem v celou a v pul
Mode 4:   Kukacky se signalem jako v mode 3, navic jedno pipnuti ve ctvrt a tri pipnuti ve tri ctvrte.
*/


//ESP32_NCV.ino - 09.06.2021 - vychazi z ESP32_NC (bez BT), volba casoveho ofsetu a letniho casu - upravim knihovnu DiesP - s parametry Offset, letni cas


// 20.04.2020  Dual_Clock_1, upraveno pro plosny spoj (jine pouzite vystupy)

#define AP_Channel_Number 11

#define DS3231_ADDRESS 0x68 
#define DS3231_REG_TIMEDATE 0x00
#define DS3231_Control_Register 0x0E
#include "Arduino.h"

//#include <My_I2C.h>
#include <DiesP.h>
#include "WiFi.h"
#include <WebServer.h> 
#include <Wire.h>
#include <EEPROM.h>

//#include <esp_wifi.h>

#define seg_a  14      	//18
#define seg_b  27      	//17
#define seg_c  25      	//32
#define seg_d  32		//33
#define seg_e  33		//25
#define seg_f  12		//26
#define seg_g  26		//27
#define seg_t  15		//14


#define digit_1  19		//12 
#define digit_2  18		//13
#define digit_3  5		//23
#define digit_4  17		//19
#define digit_5  16		//16
#define digit_6  4		//15


#define SDA_PIN 22
#define SCL_PIN 21 

#define Sound_Pin 13

#define Decrease_Pin  2
#define Out_SW_Pin  23

#define TL_1   0


#define AD_Input  36     //vstup pouziteho prevodniku


char my_ssid[32];
char my_password[32];
char Time_Server[32];


const int NTP_PACKET_SIZE = 48; // NTP time stamp is in the first 48 bytes of the message
uint8_t packetBuffer[ NTP_PACKET_SIZE]; //buffer to hold incoming and outgoing packets
unsigned long Sec_Since_2016;

uint16_t U_Array[]={0,80,250,400,600,850,1250,1600,2000,2500,3000,3700,3900,4100};
uint16_t D_Array[]={2290,2000,1800,1153,769,512,350,200,130,90,65,40,30,10,1};

uint8_t	jed_sec_BCD;
uint8_t	des_sec_BCD;
uint8_t	jed_min_BCD;
uint8_t	des_min_BCD;
uint8_t	jed_hod_BCD;
uint8_t	des_hod_BCD;

uint8_t Hour_BCD, Min_BCD, Sec_BCD;
uint8_t Dvt_BCD, Date_BCD, Month_BCD, Year_BCD;

uint16_t short_preset;

uint16_t preset;
uint16_t preset_enabled;
uint16_t preset_ind;

int freq = 600;
int ledc_channel = 0;
int resolution = 8;

bool TL_1_Used;
bool Server_Enabled;

IPAddress ip(10,160,4,5);
IPAddress gateway(10,160,4,1);
IPAddress subnet(255,255,255,0);
int Networks_Count;
String Nets_List;
String  content;
int statusCode;
uint8_t attempt_counter;
bool connected = false;

uint8_t At_H = 2;
uint8_t At_M = 30;
uint8_t Sig_Mode = 1;
uint8_t Synchro_indicator;

uint8_t Decrease_From_Hour;
uint8_t Decrease_From_Min;
uint8_t Decrease_To_Hour;
uint8_t Decrease_To_Min;

uint8_t Out_SW_From_Hour;
uint8_t Out_SW_From_Min;
uint8_t Out_SW_To_Hour;
uint8_t Out_SW_To_Min;


uint16_t From_Min;
uint16_t To_Min;
uint16_t Actual_Min;

uint16_t Uadc;

uint16_t Digit_On;
uint16_t Digit_Off;
uint16_t Ureg;
uint16_t Utab;
float koeficient;

int8_t Synchronised;

uint16_t Reference;
int  Hystereze;

int8_t GMT_offset = 2;
uint8_t Summer_Time_Enable = 1;
uint8_t spec_ind =1;


WebServer My_Server(80);

WiFiUDP Udp;
DiesP Spocitej;
TaskHandle_t Task1, Task2;
SemaphoreHandle_t baton;


//----------------------------------------------------------------------------------------------------------------------------------------
void codeForTask1( void * parameter )
{
	for (;;) 
 {
	 delay(1);
	switch(Sig_Mode) 
	{
	case 0: 	          // bez zvuku
		if (preset > 0)
		{   
		//ledcWriteTone(ledc_channel, 1000);		
		delay(130);
		//ledcWrite(ledc_channel, 0); // notone
		preset --;
		}
		else if (short_preset > 0)
		{
		delay(200);
		short_preset --;
		}	
		break;	
    case 1:              // jedno pipnuti kazdou celou hodinu
          if (preset > 0)
		  {
			  if(preset_ind == 0x00)
			  {
				ledcWriteTone(ledc_channel, 1200);		
				delay(300);
				ledcWrite(ledc_channel, 0); // notone
				delay(800);
			  }
				preset = 0;	  
			  
		  }
		  break;	
		  
	case 2: 				//kazdou celou hodinu pipani poslednich pet sekund s poslednim delsim pipnutim
        if (preset > 0)	
			{
				if(preset_ind == 0x00)
				{	
				if(preset == 1)
				{
				ledcWriteTone(ledc_channel, 1200);		
				delay(500);
				ledcWrite(ledc_channel, 0); // notone
				delay(500);
				preset --;	
				}
				else
				{
	
				ledcWriteTone(ledc_channel, 1200);		
				delay(100);
				ledcWrite(ledc_channel, 0); // notone
				delay(900);
				preset --;
				}
				}
				else
				{
				preset = 0;	
				}
			}
		    break;
		 
	case 3: 						//Kukacky se signalem v celou a v pul
		if (preset > 0)
		{   
		ledcWriteTone(ledc_channel, 710);		//667
		delay(130);
		ledcWrite(ledc_channel, 0); // notone
		delay(150);
		ledcWriteTone(ledc_channel, 600);   	//545
		delay(220);
		ledcWrite(ledc_channel, 0); // notone
		delay(500);
		preset --;
		}
		else if (short_preset > 0)
		{
		//ledcWriteTone(ledc_channel, 1900);
		//delay(120);
		//ledcWrite(ledc_channel, 0); // notone
		delay(200);
		short_preset --;
		}	
		break;		
	case 4: 	
		if (preset > 0)
		{   
		ledcWriteTone(ledc_channel, 710);		//667
		delay(130);
		ledcWrite(ledc_channel, 0); // notone
		delay(150);
		ledcWriteTone(ledc_channel, 600);   	//545
		delay(220);
		ledcWrite(ledc_channel, 0); // notone
		delay(500);
		preset --;
		}
		else if (short_preset > 0)
		{
		ledcWriteTone(ledc_channel, 1900);
		delay(120);
		ledcWrite(ledc_channel, 0); // notone
		delay(200);
		short_preset --;
		}	
		break;			
	}	
 }
}
//----------------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------
void codeForTask2( void * parameter )
{
  for (;;) 
  {  
		DS3231_ReadTime();
		Preset_Controll();
		
		jed_hod_BCD = Hour_BCD & 0x0F;
	    des_hod_BCD = Hour_BCD / 16;
	   
	    jed_min_BCD = Min_BCD & 0x0F;
	    des_min_BCD = Min_BCD / 16;
	   
	    jed_sec_BCD = Sec_BCD & 0x0F;
	    des_sec_BCD = Sec_BCD / 16;
				
		
		Decoder(des_hod_BCD);
		digitalWrite(digit_1,HIGH);
		delayMicroseconds(Digit_On);
		digitalWrite(digit_1,LOW);
		All_Segment_Off();
		delayMicroseconds(Digit_Off);
		Decoder(jed_hod_BCD);
		
		digitalWrite(digit_2,HIGH);
		delayMicroseconds(Digit_On);
		digitalWrite(digit_2,LOW);
		All_Segment_Off();	
		delayMicroseconds(Digit_Off);

		Decoder(des_min_BCD);
		
		if(Synchronised == 1)
		{
			if (Sec_BCD & 0x01)
			{
			digitalWrite(seg_t,HIGH);
			}
		}
		else
		{
			digitalWrite(seg_t,HIGH);
			
		}
		digitalWrite(digit_3,HIGH);
		delayMicroseconds(Digit_On);
		digitalWrite(digit_3,LOW);
		All_Segment_Off();
		digitalWrite(seg_t,LOW);
		
		delayMicroseconds(Digit_Off);
				
		Decoder(jed_min_BCD);
		digitalWrite(digit_4,HIGH);
		delayMicroseconds(Digit_On);
		digitalWrite(digit_4,LOW);		
		All_Segment_Off();
		delayMicroseconds(Digit_Off);

		Decoder(des_sec_BCD);
		digitalWrite(digit_5,HIGH);
		delayMicroseconds(Digit_On);
		digitalWrite(digit_5,LOW);
		All_Segment_Off();
		delayMicroseconds(Digit_Off);
				
		Decoder(jed_sec_BCD);
		digitalWrite(digit_6,HIGH);
		delayMicroseconds(Digit_On);
		digitalWrite(digit_6,LOW);		
		All_Segment_Off();
		delayMicroseconds(Digit_Off);		
  }
}
//----------------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------- All_Segment_Off ------------------------------------------------------------------------------
void All_Segment_Off()
{ 
	digitalWrite(seg_a,LOW);
	digitalWrite(seg_b,LOW);
	digitalWrite(seg_c,LOW);
	digitalWrite(seg_d,LOW);
	digitalWrite(seg_e,LOW);
	digitalWrite(seg_f,LOW);
	digitalWrite(seg_g,LOW);
}
//----------------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------
//................................................ setup begin............................................................................
void setup() 
{
  Serial.begin(115200);
  EEPROM.begin(512);
  RD_EEPROM(); 
//_______________________________
  xTaskCreatePinnedToCore(
    codeForTask1,
    "Accoustic_Task",
    1000,
    NULL,
    1,
    &Task1,
    0);
//_______________________________
//_______________________________
  xTaskCreatePinnedToCore(
    codeForTask2,
    "Display_Task",
    1000,
    NULL,
    1,
    &Task2,
    1);
//_______________________________
    Wire.begin(SDA_PIN,SCL_PIN);
	WiFi.disconnect();	
	
	pinMode(Decrease_Pin,OUTPUT);
	pinMode(Out_SW_Pin,OUTPUT);
	
	pinMode(seg_a,OUTPUT);
	pinMode(seg_b,OUTPUT);
	pinMode(seg_c,OUTPUT);
	pinMode(seg_d,OUTPUT);
	pinMode(seg_e,OUTPUT);
	pinMode(seg_f,OUTPUT);
	pinMode(seg_g,OUTPUT);
	pinMode(seg_t,OUTPUT);
	
	digitalWrite(seg_a,HIGH);
	digitalWrite(seg_b,HIGH);
	digitalWrite(seg_c,HIGH);
	digitalWrite(seg_d,HIGH);
	digitalWrite(seg_e,HIGH);
	digitalWrite(seg_f,HIGH);
	digitalWrite(seg_g,HIGH);
	digitalWrite(seg_t,HIGH);
	
	pinMode(digit_1,OUTPUT);
	pinMode(digit_2,OUTPUT);
	pinMode(digit_3,OUTPUT);
	pinMode(digit_4,OUTPUT);
	pinMode(digit_5,OUTPUT);
	pinMode(digit_6,OUTPUT);
	
	digitalWrite(digit_1,LOW);
	digitalWrite(digit_2,LOW);
	digitalWrite(digit_3,LOW);
	digitalWrite(digit_4,LOW);
	digitalWrite(digit_5,LOW);
	digitalWrite(digit_6,LOW);
	
	Reference = 1500;
	Hystereze = 0;
	
	Digit_On = 1000;
	Digit_Off = 2000;
	pinMode(TL_1,INPUT_PULLUP);
	
	//RTC_Init();
	
	ledcSetup(ledc_channel, freq, resolution);
    ledcAttachPin(Sound_Pin, ledc_channel);	
	Get_Internet_Time();
}
//............................................. setup end ...............................................................................
//............................................. loop begin ..............................................................................
void loop() 
{
	 delay(100);
	 
	 Uadc = analogRead(AD_Input);
	 if (Uadc > 4000) Uadc = 4000;
	 
	 Search_for_Digit();
 
	 Digit_Off = 2300 - Digit_On;
	 
	// ............................  Degrease ................................................................. 
	 
	 Actual_Min =  60 * BcdToUint8(Hour_BCD) + BcdToUint8(Min_BCD) ;
	 From_Min = 60 * Decrease_From_Hour + Decrease_From_Min;
	 To_Min = 60 * Decrease_To_Hour + Decrease_To_Min;
	 
	if (Decide_In_Inteerval(From_Min, To_Min, Actual_Min) == 1)      // pro pokles hlasitosti	 
	 {
		digitalWrite(Decrease_Pin,LOW); 
	 }
	 else
	 {
		digitalWrite(Decrease_Pin,HIGH);  
	 }
	//....................................................................................................
	// ............................  OUT_SW ................................................................. 	 
	 From_Min = 60 * Out_SW_From_Hour + Out_SW_From_Min;
	 To_Min = 60 * Out_SW_To_Hour + Out_SW_To_Min;
	 
	if (Decide_In_Inteerval(From_Min, To_Min, Actual_Min) == 1)      // pro pokles hlasitosti	 
	 {
		digitalWrite(Out_SW_Pin,HIGH); 
	 }
	 else
	 {
		digitalWrite(Out_SW_Pin,LOW);  
	 }	 
	//....................................................................................................	 	 
    //................................... SYNCHRO ........................................................		 		 
	 if(Synchro_indicator == 0)
	 {
		if(Test_For_Synchro() == true)
		{
			Get_Internet_Time(); 
			Synchro_indicator = 1;
		}		
	 }
	 
	 if(Test_For_Synchro() == false)
		{ 
			Synchro_indicator = 0;
		}		
	 //.................................... SERVER ......................................................
     if(TL_1_Used == false)
	 {	 
        if(digitalRead(TL_1) == 0)
		{
			TL_1_Used = true;
			Serial.println("TL_1 Pressed ");
			//Get_Internet_Time();
			Server_Enabled = true;
			Setting_Mode();
		}
	 }
     if(digitalRead(TL_1) == 1)
		{
			TL_1_Used = false;			
		}
}
//............................................. loop end ................................................................................

//--------------------------------------- Count_Minutes --------------------------------------------------------------------------------------------
uint16_t Count_Minutes(uint8_t BCD_H, uint8_t BCD_M)
{
	return  60 * BcdToUint8(BCD_H) + BcdToUint8(BCD_M) ;	
}
//-------------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------ Test_For_Synchro --------------------------------------------------------------------------------------------
bool Test_For_Synchro()
{
	bool result;
	    if ((BcdToUint8(Hour_BCD) == At_H) & (BcdToUint8(Min_BCD) == At_M))					
		{
			result = true;
		}
		else
		{
			result = false;
		}

		return result;
}
//--------------------------------------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------- Preset_Controll --------------------------------------------------------------------------
void  Preset_Controll()
{	

    if (preset_enabled == 1)
	{
		if(Sig_Mode == 2)
		{
			if ((Min_BCD == 0x59) && (Sec_BCD == 0x55))
			{
			preset = 5;
			preset_ind = 0x00;
			preset_enabled = 0;
			}	
		}
		else
		{
			if (Min_BCD == 0x15)
			{
			short_preset = 1;
			preset_ind = 0x15;
			preset_enabled = 0;
			}
		
			if (Min_BCD == 0x45)
			{
			short_preset = 3;
			preset_ind = 0x45;
			preset_enabled = 0;
			}
		
			if (Min_BCD == 0x30)
			{
			preset = 1;		
			preset_enabled = 0;
			preset_ind = 0x30;
			}				
		
			if (Min_BCD == 0x00)
			{	
			preset_ind = 0x00;
			preset = BcdToUint8(Hour_BCD);
				if (Hour_BCD == 0) 
				{
				preset = 12;
				}
					while (preset > 12)
					{
						preset = preset - 12;
					}	
				preset_enabled = 0;
				preset_ind = 0x00;
			}
	}
	}
		
	if(Min_BCD != preset_ind )
	{
		preset_enabled = 1;
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------- Decoder ------------------------------------------------------------------------------------
void Decoder(uint8_t number)
{
	switch(number)
	{
		case 0:
		{
			digitalWrite(seg_a,HIGH);
			digitalWrite(seg_b,HIGH);
			digitalWrite(seg_c,HIGH);
			digitalWrite(seg_d,HIGH);
			digitalWrite(seg_e,HIGH);
			digitalWrite(seg_f,HIGH);
			digitalWrite(seg_g,LOW);
			break;
		}
		case 1:
		{
			digitalWrite(seg_a,LOW);
			
			digitalWrite(seg_b,HIGH);
			digitalWrite(seg_c,HIGH);
			
			digitalWrite(seg_d,LOW);
			digitalWrite(seg_e,LOW);
			digitalWrite(seg_f,LOW);
			digitalWrite(seg_g,LOW);
			break;
		}
		case 2:
		{
			digitalWrite(seg_a,HIGH);
			digitalWrite(seg_b,HIGH);
			
			digitalWrite(seg_c,LOW);
			
			digitalWrite(seg_d,HIGH);
			digitalWrite(seg_e,HIGH);
			
			digitalWrite(seg_f,LOW);
			
			digitalWrite(seg_g,HIGH);
			break;
		}
		case 3:
		{
			digitalWrite(seg_a,HIGH);
			digitalWrite(seg_b,HIGH);
			digitalWrite(seg_c,HIGH);
			digitalWrite(seg_d,HIGH);
			
			digitalWrite(seg_e,LOW);
			digitalWrite(seg_f,LOW);
			
			digitalWrite(seg_g,HIGH);
			break;
		}
		case 4:
		{
			digitalWrite(seg_a,LOW);
			digitalWrite(seg_b,HIGH);
			digitalWrite(seg_c,HIGH);
			digitalWrite(seg_d,LOW);
			digitalWrite(seg_e,LOW);
			digitalWrite(seg_f,HIGH);
			digitalWrite(seg_g,HIGH);
			break;
		}
		case 5:
		{
			digitalWrite(seg_a,HIGH);
			digitalWrite(seg_b,LOW);
			digitalWrite(seg_c,HIGH);
			digitalWrite(seg_d,HIGH);
			digitalWrite(seg_e,LOW);
			digitalWrite(seg_f,HIGH);
			digitalWrite(seg_g,HIGH);
			break;
		}
		case 6:
		{
			digitalWrite(seg_a,HIGH);
			digitalWrite(seg_b,LOW);
			digitalWrite(seg_c,HIGH);
			digitalWrite(seg_d,HIGH);
			digitalWrite(seg_e,HIGH);
			digitalWrite(seg_f,HIGH);
			digitalWrite(seg_g,HIGH);
			break;
		}
		case 7:
		{
			digitalWrite(seg_a,HIGH);
			digitalWrite(seg_b,HIGH);
			digitalWrite(seg_c,HIGH);
			digitalWrite(seg_d,LOW);
			digitalWrite(seg_e,LOW);
			digitalWrite(seg_f,LOW);
			digitalWrite(seg_g,LOW);
			break;
		}
		case 8:
		{
			digitalWrite(seg_a,HIGH);
			digitalWrite(seg_b,HIGH);
			digitalWrite(seg_c,HIGH);
			digitalWrite(seg_d,HIGH);
			digitalWrite(seg_e,HIGH);
			digitalWrite(seg_f,HIGH);
			digitalWrite(seg_g,HIGH);
			break;
		}
		case 9:
		{
			digitalWrite(seg_a,HIGH);
			digitalWrite(seg_b,HIGH);
			digitalWrite(seg_c,HIGH);
			digitalWrite(seg_d,HIGH);
			digitalWrite(seg_e,LOW);
			digitalWrite(seg_f,HIGH);
			digitalWrite(seg_g,HIGH);
			break;
		}
		case 10:
		{
			digitalWrite(seg_a,HIGH);
			digitalWrite(seg_b,HIGH);
			digitalWrite(seg_c,HIGH);
			digitalWrite(seg_d,LOW);
			digitalWrite(seg_e,HIGH);
			digitalWrite(seg_f,HIGH);
			digitalWrite(seg_g,HIGH);
			break;
		}
		case 11:
		{
			digitalWrite(seg_a,LOW);
			digitalWrite(seg_b,LOW);
			digitalWrite(seg_c,HIGH);
			digitalWrite(seg_d,HIGH);
			digitalWrite(seg_e,HIGH);
			digitalWrite(seg_f,HIGH);
			digitalWrite(seg_g,HIGH);
			break;		
		}
		case 12:
		{
			digitalWrite(seg_a,HIGH);
			digitalWrite(seg_b,LOW);
			digitalWrite(seg_c,LOW);
			digitalWrite(seg_d,HIGH);
			digitalWrite(seg_e,HIGH);
			digitalWrite(seg_f,HIGH);
			digitalWrite(seg_g,LOW);
			break;
		}
		case 13:
		{
			digitalWrite(seg_a,LOW);
			digitalWrite(seg_b,HIGH);
			digitalWrite(seg_c,HIGH);
			digitalWrite(seg_d,HIGH);
			digitalWrite(seg_e,HIGH);
			digitalWrite(seg_f,LOW);
			digitalWrite(seg_g,HIGH);
			break;
		}
		case 14:
		{
			digitalWrite(seg_a,HIGH);
			digitalWrite(seg_b,LOW);
			digitalWrite(seg_c,LOW);
			digitalWrite(seg_d,HIGH);
			digitalWrite(seg_e,HIGH);
			digitalWrite(seg_f,HIGH);
			digitalWrite(seg_g,HIGH);
			break;
		}
		case 15:
		{
			digitalWrite(seg_a,HIGH);
			digitalWrite(seg_b,LOW);
			digitalWrite(seg_c,LOW);
			digitalWrite(seg_d,LOW);
			digitalWrite(seg_e,HIGH);
			digitalWrite(seg_f,HIGH);
			digitalWrite(seg_g,HIGH);
			break;
		}
	}	
}
//----------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------- DS3231_Write_Time --------------------------------------------------------------------
void DS3231_Write_Time()
{
    Wire.beginTransmission(DS3231_ADDRESS);
    Wire.write(DS3231_REG_TIMEDATE);           
    Wire.write(Uint8ToBcd(Sec_BCD));
	Wire.write(Uint8ToBcd(Min_BCD));
	Wire.write(Uint8ToBcd(Hour_BCD));
	Wire.write(Uint8ToBcd(Dvt_BCD));
	Wire.write(Uint8ToBcd(Date_BCD));
	Wire.write(Uint8ToBcd(Month_BCD));
	Wire.write(Uint8ToBcd(Year_BCD));
    Wire.endTransmission();
}
//------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------- ReadTime -----------------------------------------------------------------------
void DS3231_ReadTime()
{
    Wire.beginTransmission(DS3231_ADDRESS);
    Wire.write(DS3231_REG_TIMEDATE);           
    Wire.endTransmission();
	
	Wire.requestFrom(DS3231_ADDRESS, 7);
	Sec_BCD = (Wire.read());
	Min_BCD = (Wire.read());	
    Hour_BCD = (Wire.read());
    Dvt_BCD = (Wire.read());
    Date_BCD = (Wire.read());
    Month_BCD = (Wire.read());
    Year_BCD = (Wire.read());
}
//------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------  BcdToUint8 -----------------------------------------------------------------------
uint8_t BcdToUint8(uint8_t val)
{
    return val - 6 * (val >> 4);
}
//------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------ Uint8ToBcd ------------------------------------------------------------------------
uint8_t Uint8ToBcd(uint8_t val)
{
    return val + 6 * (val / 10);
}
//------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------Connect_To_WiFi -------------------------------------------------------------
void  Connect_To_WiFi(void)
{
	WiFi.disconnect();
	delay(500);
	
	Serial.println();
	Serial.print("SSID: ");
	Serial.println(my_ssid);
	
	Serial.print("PASSW: ");
	Serial.println(my_password);
		
	WiFi.mode(WIFI_STA);
	delay(1000);
	
	WiFi.begin(my_ssid, my_password);
	
	attempt_counter= 0;
	
	while(WiFi.status() != WL_CONNECTED)
	{ 	
      delay(1000);
	  attempt_counter += 1;
      Serial.print(attempt_counter);
	  Serial.print(" . ");
	  if (attempt_counter > 15)
	  {
		  Serial.println("Giving up ... ");
		  break;
	  }  
	}
	if (WiFi.status() == WL_CONNECTED)
	{		
	connected = true;
    Serial.println();
	Serial.println("WiFi logged");	
	}
	else
	{
	connected = false;
    Serial.println();
	Serial.println("Not connected");	
	}	
	
}	
//---------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------- Get_Internet_Time -----------------------------------------------------------------
void  Get_Internet_Time()
{
	Synchronised = 0;
	Connect_To_WiFi();
	if (connected == true)
	{
		SNTP();
	}
	WiFi.mode(WIFI_OFF);
}
//---------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------- SNTP --------------------------------------------------------------------
void SNTP()
{   
  Udp.begin(8888);
  delay(100);
  sendNTPpacket(Time_Server); 
  delay(2000);
  if (Udp.parsePacket()) 
      {
    Udp.read(packetBuffer, NTP_PACKET_SIZE); // read the packet into the buffer 
    Serial.println("UDP Packet Received");
    unsigned long highWord = word(packetBuffer[40], packetBuffer[41]);
    word lowWord = word(packetBuffer[42], packetBuffer[43]);
    unsigned long secsSince1900 = highWord << 16 | lowWord;
    
    Sec_Since_2016 = secsSince1900 - 3660595200;   
	
	Sec_Since_2016 += 2;  // sekundova korekce	
	//delay(300);		     // jemna korekce	
    Spocitej.Count_Dies(Sec_Since_2016,GMT_offset,Summer_Time_Enable);
	
	Hour_BCD = Spocitej.D_Hour;
	Min_BCD = Spocitej.D_Minute;
	Sec_BCD = Spocitej.D_Second;
	
	Dvt_BCD = Spocitej.D_Week_Day;
	Date_BCD = Spocitej.D_Date;
	Month_BCD = Spocitej.D_Month;
	Year_BCD = Spocitej.D_Year - 2000;
    
	DS3231_Write_Time();
    if (Spocitej.D_Hour < 10)
    {
      Serial.print("0");
    }
    Serial.print(Spocitej.D_Hour);
    Serial.print(":");
    if (Spocitej.D_Minute < 10)
    {
      Serial.print("0");
    }
    Serial.print(Spocitej.D_Minute);
    Serial.print(":");
    if (Spocitej.D_Second < 10)
    {
      Serial.print("0");
    }
    Serial.print(Spocitej.D_Second);
    Serial.print(" / ");
    if (Spocitej.D_Date < 10)
    {
      Serial.print("0");
    }
    Serial.print(Spocitej.D_Date);
    Serial.print(".");
    if (Spocitej.D_Month < 10)
    {
      Serial.print("0");
    }
    Serial.print(Spocitej.D_Month);
    Serial.print(".");
    Serial.print(Spocitej.D_Year);
    Serial.print(" - ");
    Serial.print(Spocitej.D_Week_Day);
    Serial.println();   
    //delay(100);
	
	Synchronised = 1;
      }
    else
    {
     Serial.println("UDP Error");
    }
     Udp.stop();
}
//---------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------- sendNTPpacket -----------------------------------------------------------------
// send an NTP request to the time server at the given address
void sendNTPpacket(char* address) {
  
  memset(packetBuffer, 0, NTP_PACKET_SIZE);  // set all bytes in the buffer to 0
  // Initialize values needed to form NTP request
  packetBuffer[0] = 0b11100011;   // LI, Version, Mode
  packetBuffer[1] = 0;     // Stratum, or type of clock
  packetBuffer[2] = 6;     // Polling Interval
  packetBuffer[3] = 0xEC;  // Peer Clock Precision
  // 8 bytes of zero for Root Delay & Root Dispersion
  packetBuffer[12]  = 49;
  packetBuffer[13]  = 0x4E;
  packetBuffer[14]  = 49;
  packetBuffer[15]  = 52;
  // all NTP fields have been given values, now you can send a packet requesting a timestamp:
  Udp.beginPacket(address, 123); //NTP requests are to port 123
  Udp.write(packetBuffer, NTP_PACKET_SIZE);
  Udp.endPacket();
}
//---------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- Setting_Mode ----------------------------------------------------------------
void  Setting_Mode(void)
{	
	Setup_AP_Server();
	while(Server_Enabled == true)
	{		
	delay(100);
	My_Server.handleClient(); 
	
	if(TL_1_Used == false)
	 {	 
        if(digitalRead(TL_1) == 0)
		{
			TL_1_Used = true;
			Serial.println("TL_1 Pressed ");
			Server_Enabled = false;	
			WiFi.softAPdisconnect(true);
			//delay(1000);
			//WiFi.mode(WIFI_STA);
			delay(1000);
			WiFi.mode(WIFI_OFF);	
		}
	 }
     if(digitalRead(TL_1) == 1)
		{
			TL_1_Used = false;			
		}
	} 
}
//---------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------ Setup_AP_Server ----------------------------------------------------------------
void Setup_AP_Server(void)
{
	Serial.println();
	Serial.println("SETUP AP SERVER ");
	WiFi.disconnect();
	delay(500);
    WiFi.mode(WIFI_AP);  
	delay(500);
	WiFi.softAPConfig(ip,gateway,subnet);
	delay(100);
    WiFi.softAP("My_ESP","clock",AP_Channel_Number);     // zapne AP na kanale 11
	delay(100);	
    Serial.print("IP address: ");
    Serial.println(WiFi.softAPIP());  
 	My_Server.begin();
	Create_Web_Server();
}
//---------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------- Create_Web_Server ---------------------------------------------------------------
void  Create_Web_Server(void)
{
	My_Server.on("/", []() 
	{  
    Build_Content();
    My_Server.send(200, "text/html", content);
    });
	
	My_Server.on("/setting",[]() 
	{   
	Decode_Presets();
    content = "Success, data saved.";
    statusCode = 200;        
    My_Server.send(statusCode, "text/html", content);
    });
}
//---------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------- Build_Content -------------------------------------------------------------
void Build_Content()
{		
	  Scan_For_Networks();
	  
	  content = "<!DOCTYPE HTML>\r\n<html> "; 
	  content += "<body>";
	  content += "<font size='6'>Clock Preset </font><br><br>";

	  content += "Avalaible nets:";
      content += "<p>";
      content += Nets_List;
      content += "</p>";
      content += "WiFi to connect:";
      content += "<br> ";
      content += "<form method='get' action='setting'>SSID: <input name='ssid' maxlength=32 value= ";
      content += my_ssid;
      content += ">&nbsp;&nbsp; PASSW: <input name='pass' maxlength=32 value= ";
      content += my_password;
      content += "><br><br>";

	  content += "<form method='get' action='setting'> Synchro at HH: <input name='AtH' maxlength=2 size=1 value= ";
      if (At_H < 10) {
        content += "0";
      }
      content += String(At_H);
      content += "><form method='get' action='setting'> MM: <input name='AtM' maxlength=2 size=1 value= ";
      if (At_M < 10) {
        content += "0";
      }
      content += String(At_M);
	
      content += "><br><br>";
	  content += "SNTP:";
	  content += "<br> ";
	  content += "<form method='get' action='setting'><label>Time Server: </label><input name='Tim_Srv' length=32 value= ";	  
	  content += Time_Server;
	  content += "><br><br>";
	  content += "<form method='get' action='setting'> Signal Mode: <input name='Sig' maxlength=2 size=1 value= ";
      content += String(Sig_Mode);
	  
	  
	  content += "> &nbsp;&nbsp; <form method='get' action='setting'><label>GMT offset: </label><input name='GMT_ofs' maxlength= 3 size=1 value= "; 
	  content += String(GMT_offset);
	  
	  content += "> &nbsp;&nbsp; <input type='checkbox' name='sum_tim' value='ST_yes' ";	  
	  if (Summer_Time_Enable == 0x01)
	  {
		  content += "checked";
	  }
	  
	  content += "> Summer Time";
	  
	  content += "<br><br><form method='get' action='setting'> Degrease from HH: <input name='FroH' maxlength=2 size=1 value= ";
      if (Decrease_From_Hour < 10) {
        content += "0";
      }
      content += String(Decrease_From_Hour);
      content += "><form method='get' action='setting'> MM: <input name='FroM' maxlength=2 size=1 value= ";
      if (Decrease_From_Min < 10) {
        content += "0";
      }
      content += String(Decrease_From_Min);
	  
	  content += "><form method='get' action='setting'><label> &nbsp;&nbsp; To HH: <input name='ToH' maxlength=2 size=1 value= ";
      if (Decrease_To_Hour < 10) {
        content += "0";
      }
      content += String(Decrease_To_Hour);
      content += "><form method='get' action='setting'> MM: </label><input name='ToM' maxlength=2 size=1 value= ";
      if (Decrease_To_Min < 10) {
        content += "0";
      }
      content += String(Decrease_To_Min);
	  
	  
	  content += "><br><br><form method='get' action='setting'> Switch from HH: <input name='SWFroH' maxlength=2 size=1 value= ";
      if (Out_SW_From_Hour < 10) {
        content += "0";
      }
      content += String(Out_SW_From_Hour);
      content += "><form method='get' action='setting'> MM: <input name='SWFroM' maxlength=2 size=1 value= ";
      if (Out_SW_From_Min < 10) {
        content += "0";
      }
      content += String(Out_SW_From_Min);
	  
	  content += "><form method='get' action='setting'><label> &nbsp;&nbsp; To HH: <input name='SWToH' maxlength=2 size=1 value= ";
      if (Out_SW_To_Hour < 10) {
        content += "0";
      }
      content += String(Out_SW_To_Hour);
      content += "><form method='get' action='setting'> MM: </label><input name='SWToM' maxlength=2 size=1 value= ";
      if (Out_SW_To_Min < 10) {
        content += "0";
      }
      content += String(Out_SW_To_Min);	  
	  
	  content += "><br><br><br>";     
      content += "<input type='submit' value='WRITE'>";
      content += "</form>";
	  content += "</body>";
      content += "</html>";	 
}
//----------------------------------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------- Decode_Presets --------------------------------------------------------------------------
void  Decode_Presets(void)
{
      String qsid = My_Server.arg("ssid");
      String qpass = My_Server.arg("pass");
	  String Time_Server_x = My_Server.arg("Tim_Srv"); 
	  
      String At_H_$ = My_Server.arg("AtH");
      String At_M_$ = My_Server.arg("AtM");
      String Sig_M_$ = My_Server.arg("Sig");

	  String From_H_$ = My_Server.arg("FroH");	
	  String From_M_$ = My_Server.arg("FroM");
      String To_H_$ = My_Server.arg("ToH");	
	  String To_M_$ = My_Server.arg("ToM");
	  
	  String SWFrom_H_$ = My_Server.arg("SWFroH");	
	  String SWFrom_M_$ = My_Server.arg("SWFroM");
      String SWTo_H_$ = My_Server.arg("SWToH");	
	  String SWTo_M_$ = My_Server.arg("SWToM");
	  
	  String GMT_offset_$ = My_Server.arg("GMT_ofs");
	  String Summer_Time_Enable_$ = My_Server.arg("sum_tim"); 
	  
	  GMT_offset = GMT_offset_$.toInt();
	  
	  if (Summer_Time_Enable_$ == "ST_yes")
	  {
		  Summer_Time_Enable = 0x01;
	  }
	  else
	  {
		  Summer_Time_Enable = 0x00;
	  } 	
	    
      At_H = At_H_$.toInt();
      At_M = At_M_$.toInt();
      Sig_Mode = Sig_M_$.toInt();
	  
	  Decrease_From_Hour = From_H_$.toInt();
	  Decrease_From_Min = From_M_$.toInt();
	  Decrease_To_Hour = To_H_$.toInt();
	  Decrease_To_Min = To_M_$.toInt();	  
      
	  Out_SW_From_Hour = SWFrom_H_$.toInt();
	  Out_SW_From_Min = SWFrom_M_$.toInt();
	  Out_SW_To_Hour = SWTo_H_$.toInt();
	  Out_SW_To_Min = SWTo_M_$.toInt();	 	  
	  
	for (int i = 0; i < 512; ++i) { EEPROM.write(i, 0xFF); }
	
		uint16_t eepaddress = 0;
		for (int i = 0; i < qsid.length(); ++i)
            {
              EEPROM.write(eepaddress + i, qsid[i]);             
            }
			
        eepaddress = 32;  
        for (int i = 0; i < qpass.length(); ++i)
            {
              EEPROM.write(eepaddress + i, qpass[i]); 
            }  
		eepaddress = 64;
		for (int i = 0; i < Time_Server_x.length(); ++i)
            {
              EEPROM.write(eepaddress + i, Time_Server_x[i]);   
            }  		
			
			EEPROM.write(128,At_H);
			EEPROM.write(129,At_M);
			EEPROM.write(130,Sig_Mode);
			
			EEPROM.write(131,Decrease_From_Hour);
			EEPROM.write(132,Decrease_From_Min);
			EEPROM.write(133,Decrease_To_Hour);
			EEPROM.write(134,Decrease_To_Min);
			
			EEPROM.write(135,Out_SW_From_Hour);
			EEPROM.write(136,Out_SW_From_Min);
			EEPROM.write(137,Out_SW_To_Hour);
			EEPROM.write(138,Out_SW_To_Min);
			
			EEPROM.write(139,GMT_offset);
			EEPROM.write(140,Summer_Time_Enable);
				
            EEPROM.commit();
			delay(10);			
			RD_EEPROM();
}

//---------------------------------------------- Scan_For_Networks ---------------------------------------------------------------------------------
void Scan_For_Networks()
{ 
  Networks_Count = WiFi.scanNetworks();
  Nets_List = "<ol>";
  for (int i = 0; i < Networks_Count; ++i)
  {
    Nets_List += "<li>";
    Nets_List += WiFi.SSID(i);
    Nets_List += " (";
    Nets_List += WiFi.RSSI(i);
    Nets_List += ")";
    Nets_List += (WiFi.encryptionType(i) == WIFI_AUTH_OPEN) ? " " : "*";
    Nets_List += "</li>";
  }
  Nets_List += "</ol>";
}
//---------------------------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------- RD_EEPROM -------------------------------------------------------------------------------------
void RD_EEPROM()
{
	uint16_t eepaddress = 0;
	uint8_t rd_x = 0;
	
	for (int i = 0; i < 32; ++i)
	{
		my_ssid[i] = 0x00;
	}
	
	eepaddress = 0;
  for (int i = 0; i < 32; ++i)
    {
		rd_x = EEPROM.read(eepaddress + i);
		if((rd_x > 0x1F) && (rd_x < 0xA8))
		{
			my_ssid[i] = rd_x;
		}
    }
	
	for (int i = 0; i < 32; ++i)
	{
		my_password[i] = 0x00;
	}
	
	eepaddress = 32;
  for (int i = 0; i < 32; ++i)
    {
		rd_x = EEPROM.read(eepaddress + i);
		if((rd_x > 0x1F) && (rd_x < 0xA8))
		{
			my_password[i] = rd_x;
		}
    }
	
	for (int i = 0; i < 32; ++i)
	{
		Time_Server[i] = 0x00;
	}
	
	eepaddress = 64;
  for (int i = 0; i < 32; ++i)
    {
		rd_x = EEPROM.read(eepaddress + i);
		if((rd_x > 0x1F) && (rd_x < 0xA8))
		{
			Time_Server[i] = rd_x;
		}
    }
	
	At_H = EEPROM.read(128);
	At_M = EEPROM.read(129);
	Sig_Mode = EEPROM.read(130);
	
	Decrease_From_Hour = EEPROM.read(131);
	Decrease_From_Min = EEPROM.read(132);
	Decrease_To_Hour = EEPROM.read(133);
	Decrease_To_Min = EEPROM.read(134);
	
	Out_SW_From_Hour = EEPROM.read(135);
	Out_SW_From_Min = EEPROM.read(136);
	Out_SW_To_Hour = EEPROM.read(137);
	Out_SW_To_Min = EEPROM.read(138);
	
	GMT_offset = EEPROM.read(139);
	Summer_Time_Enable = EEPROM.read(140);	
	
}	
//-------------------------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------- Decide_In_Inteerval ----------------------------------------------------------------------------
int Decide_In_Inteerval(uint16_t From, uint16_t To, uint16_t Act)
{	
	if(From == To)
	{
		return 1;
	}	
  if (From <= To)
  {	  
    if ((Act >= From) & (Act < To))   // (Act <= To)
    {
      return 1;
    }
    else
    {
      return 0;
    }
  }
  else
  {
    if ((Act < From) & (Act > To))
    {   
      return 0;
    }
    else
    { 
      return 1;
    }
  }
}
//-----------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- Serial_Print_Time ----------------------------------------------------------------------------
void Serial_Print_Time()
{
	Serial.print(Hour_BCD,HEX);
	Serial.print(":");
	Serial.print(Min_BCD,HEX);
	Serial.print(":");
	Serial.print(Sec_BCD,HEX);
	Serial.print("/");
	Serial.print(Date_BCD,HEX);
	Serial.print(".");
	Serial.print(Month_BCD,HEX);
	Serial.print(".");
	Serial.print(Year_BCD,HEX);
	Serial.print("-");
	Serial.println(Dvt_BCD,HEX);
}
//--------------------------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------  RTC_Init -----------------------------------------------------------------------------------
void  RTC_Init()
{
	Wire.beginTransmission(DS3231_ADDRESS);
    Wire.write(DS3231_Control_Register);           
    Wire.write(B00011100);
    Wire.endTransmission();	
}
//--------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------------------------------
void Search_for_Digit()
{
	//float koeficient;
	float x1, x2;
	
	for (int x= 0; x < 13; x = x + 1)
	{
		if (Uadc >= U_Array[x] && Uadc <= U_Array[x+1])
		{	 
			Utab = U_Array[x];
			x1 = (Uadc - U_Array[x]);
			x2 = (U_Array[x+1] - U_Array[x]);
			koeficient = x1/x2;
	
			Digit_On = D_Array[x] + koeficient * (D_Array[x+1] - D_Array[x]); 
		}
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------